'Dual/multiple core example
'Same code; different parameters

$APPTYPE CONSOLE: $TYPECHECK ON

dim A(99,99) as DOUBLE

TYPE COREDATA
  Initial as long
  Final as long
END COREDATA

dim c1 as COREDATA, c2 as COREDATA

Declare SUB CORE1 STD (lpDat1 as long)
Declare SUB CORE2 STD (lpDat2 as long)

SUB CORE1
defint i,j,n
for n=1 to 1000  'reiterate to observe time
for i=byref(lpDat1) to byref(lpDat1+4)
  for j=0 to 99
    A(i,j) = pi  'store constant pi  
  next j
next i
next n
END SUB

SUB CORE2
defint i,j,n
for n=1 to 1000  'reiterate to observe time
for i=byref(lpDat2) to byref(lpDat2+4)
  for j=0 to 99
    A(i,j) = pi  'store constant pi  
  next j
next i
next n
END SUB

print "HotBasic Dual-Core -- CPUCOUNT, CREATETHREAD, WAITTHREAD"
defreal10 t = timer

'If you only have a dual-core machine,
'you can use the following line to compile
'for a single CPU to compare times:
'IF CPUCount > 100 THEN

IF CPUCount > one THEN
  'set up parameters
  c1.Initial = 0: c1.Final = 49
  c2.Initial = 50: c2.Final = 99
  'start CORE2
  defint CORE2ID = CreateThread codeptr(CORE2),@c2
  'main thread 
  CORE1(@c1)  'CORE1 time should be >= CORE2 time
  'wait for CORE2 to complete
  WaitThread CORE2ID
ELSE
  c1.Initial = 0: c1.Final = 99
  CORE1(@c1)  'single processor
END IF

print timer-t; " seconds"
pause
